// 
// $Id$
//
// Implementation of eZIconSet class
//
// Jan Borsodi <amos@ez.no>
// Created on: <04-Dec-1999 22:03:39 amos>
//


#include "eziconset.hpp"
#include <qwidget.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qpixmap.h>
#include <qstring.h>

/*!
  \class eZIconSet eziconset.hpp
  \brief

*/

/*!
  Default constructor
*/

eZIconSet::eZIconSet( const QString &dir, QWidget *parent, const char *name )
    : QWidget( parent, name )
{
    QHBoxLayout *lay = new QHBoxLayout( this, 3 );
    {
        QPixmap backpix( dir + "/" + "back.xpm" );
        QPixmap fopenpix( dir + "/" + "fileopen.xpm" );
        QPixmap fwdpix( dir + "/" + "forward.xpm" );
        QPixmap sldpix( dir + "/" + "slide.xpm" );
        QPixmap zinpix( dir + "/" + "zoomin.xpm" );
        QPixmap zoutpix( dir + "/" + "zoomout.xpm" );

        lay->addSpacing( 30 );

        QLabel *fopen = new QLabel( this );
        fopen->setPixmap( fopenpix );
        lay->addWidget( fopen, 0 );

        QLabel *back = new QLabel( this );
        back->setPixmap( backpix );
        lay->addWidget( back, 0 );

        QLabel *fwd = new QLabel( this );
        fwd->setPixmap( fwdpix );
        lay->addWidget( fwd, 0 );

        QLabel *sld = new QLabel( this );
        sld->setPixmap( sldpix );
        lay->addWidget( sld, 0 );

        QLabel *zin = new QLabel( this );
        zin->setPixmap( zinpix );
        lay->addWidget( zin, 0 );

        QLabel *zout = new QLabel( this );
        zout->setPixmap( zoutpix );
        lay->addWidget( zout, 0 );

        lay->addStretch( 1 );

    }
}

/*!
  Destroys the object
*/

eZIconSet::~eZIconSet()
{
}
