// 
// $Id: ezlocationselector.hpp,v 1.1.1.1 1999/12/04 20:30:05 amos Exp $
//
// Definition of eZLocationSelector class
//
// Jan Borsodi <amos@ez.no>
// Created on: <19-Aug-1999 23:58:36 amos>
//

#ifndef EZLOCATIONSELECTOR_HPP
#define EZLOCATIONSELECTOR_HPP

#include <qwidget.h>
#include <qgroupbox.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qstring.h>
#include "ezlocationselector.hpp"

class eZLocationSelector : public QWidget
{
    Q_OBJECT
public:
    eZLocationSelector( const QString &progname, QWidget *parent = 0, const char *name = 0 );
    virtual ~eZLocationSelector();

    QString binaryPath() const;
    QString installPath() const;

protected slots:
    void listSelect( int i );
    void browseClicked();
    void dirToggled( bool b );
    void setDestination();

    void binToggled( bool b );

protected:
    bool canWrite( const QString &dir );
    QString tmpName( int num );

private:
    QListBox *LBox;
    QGroupBox *GBox;
    QLineEdit *DLine;
    QPushButton *Browse;
    QLabel *InfoLabel;
    QLineEdit *SubLine;
    QCheckBox *Check;
    QCheckBox *BinCheck;
    QLabel *DestLabel;
    QGroupBox *InfBox;
    bool Browsed;
    int LastIndex;
    QStringList Strings;
    bool bBin;
    bool bInclude;
    bool bLib;
    bool bDoc;
    char *Chars;
    int CharLen;

    bool bAddBin;
    bool bAddInclude;
    bool bAddLib;
    bool bAddDoc;

    QListBoxText *DirOpt;
    QListBoxText *DirUsr;
    QListBoxText *DirUsrLib;
    QListBoxText *DirUsrLocal;
    QListBoxText *DirUsrLocalLib;
    QListBoxText *DirHome;
};


#endif // EZLOCATIONSELECTOR_HPP
