/* main.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <21-Jun-1999 03:46:55 amos>
 */

#include <iostream.h>
#include "qmmainwindow.h"
#include "qaconfig.hpp"

#include <qapplication.h>
#include <qjpegio.h>
#include <qimageio.h>
#include <qpixmap.h>
#include <qfileinfo.h>
#include <qobject.h>
#include <qdir.h>
#include <qmessagebox.h>
#include <qstring.h>
#include <iostream>
#include <qtextview.h>

#ifdef DEBUG
QTextView *g_pLog = 0;
#endif

int main(int argc, char **argv)
{

    QApplication::setColorSpec(QApplication::ManyColor);
    QApplication a(argc, argv);

    QPixmap::setDefaultOptimization(QPixmap::BestOptim);
    qInitImageIO();

#ifdef DEBUG
    qInstallMsgHandler( myMessageOutput );
#endif

    QmMainWindow *pMainWin = new QmMainWindow( 0, "main-window" );
    if ( argc > 1 )
    {
        QFileInfo d( argv[1] );
        d.convertToAbs();
        pMainWin->setPath( d.dirPath() );
        pMainWin->setPictureFile( argv[1] );
    }
//      g_pLog = pMainWin->logger();
    pMainWin->show();

    QObject::connect(qApp, SIGNAL(lastWindowClosed()),
		     pMainWin, SLOT(quit()));
    int rc = a.exec();
    QaConfig::instance()->save();
    delete pMainWin;

    delete QaConfig::instance();

    return rc;
}

#ifdef DEBUG

void myMessageOutput( QtMsgType type, const char *msg )
{
    if ( g_pLog != 0 )
    {
        switch ( type )
        {
            case QtDebugMsg:
            {
                QString s;
                s.sprintf( "<b><font color=\"#A6A5FF\">Debug:</font></b> <font color=\"white\">%s</font><br>", msg );
                g_pLog->setText( g_pLog->text() + s );
                g_pLog->setContentsPos( g_pLog->contentsX(), g_pLog->contentsHeight() - g_pLog->viewport()->height() );
                break;
            }
            case QtWarningMsg:
            {
                QString s;
                s.sprintf( "<b><font color=\"yellow\">Warning:</font></b> <font color=\"white\">%s</font><br>", msg );
                g_pLog->setText( g_pLog->text() + s );
                g_pLog->setContentsPos( g_pLog->contentsX(), g_pLog->contentsHeight() - g_pLog->viewport()->height() );
                break;
            }
            case QtFatalMsg:
            {
                QString s;
                s.sprintf( "<b><font color=\"red\">Fatal:</font></b> <font color=\"white\">%s</font><br>", msg );
                g_pLog->setText( g_pLog->text() + s );
                g_pLog->setContentsPos( g_pLog->contentsX(), g_pLog->contentsHeight() - g_pLog->viewport()->height() );
                s.sprintf( "<h1>A fatal error occured</h1>\n"
                           "Will do a core dump!<br>"
                           "<b>Error:</b><br>%s", msg );
                QMessageBox::critical( g_pLog, "Fatal error", s );
                abort();                        // dump core on purpose
            }
        }
    }
    else
    {
        cout << msg << endl;
    }
}

#endif
