// QaCommonList.cpp
//
// Jan Borsodi <jbfdata@online.no>
// Last change: Time-stamp: <03-Dec-1999 00:22:46 amos>
//
//

#include "qacommonlist.hpp"
#include <iostream.h>
#include <qimage.h>
#include <qstring.h>
#include <qdir.h>
#include <qfileinfo.h>
#include <qobject.h>
#include <iostream>
#include <qdatetime.h>

/*!
  \class QaCommonList QaCommonList.hpp
  \brief

*/

/*!
  Default constructor
*/

QaCommonList::QaCommonList( QObject *parent, const char *name )
	: QObject( parent, name )
{
	Busy = false;
}

/*!
  Destroys the object
*/

QaCommonList::~QaCommonList()
{
}

void QaCommonList::setPath( const QString &path )
{
    if ( ! Busy )
    {
        Busy = true;
        qDebug( "QaCommonList:listing directory: %s", path.ascii() );
        checkDirTime( path );
        emit beginningOfList();
        const QFileInfoList *fl = Dir.entryInfoList();
        emit directoryChanged( fl );
        QFileInfoListIterator it( *fl );
        const QFileInfo *fi;
        while ( (fi = it.current()) )
        {
            emit item( fi );
            ++it;
        }
        emit endOfList();
        Busy = false;
    }
    else
        cerr << "QaCommonList: already doing a dir job\n";
}

void QaCommonList::setDirTreePath( const QString &path )
{
    qDebug( "QaCommonListDirTree:listing directory: %s", path.ascii() );
    checkDirTime( path );
//  	emit beginningOfDirList();
//  	const QFileInfoList *fl = Dir.entryInfoList( QDir::Dirs );
//  	emit directoryDirChanged( fl );
//  	QFileInfoListIterator it( *fl );
//  	const QFileInfo *fi;
//  	while ( (fi = it.current()) )
//  	{
//  		emit itemDirTree( fi );
//  		++it;
//  	}
//  	emit endOfDirList();
}

void QaCommonList::checkDirTime( const QString &path )
{
    QFileInfo fi( path );
    if ( fi.absFilePath() == LastPath.absFilePath() )
    {
        QDateTime newmod = fi.lastModified();
        if (  newmod > LastMod )
            LastMod = newmod;
        else
            Dir.setPath( path );
    }
    else
    {
        LastPath = fi;
        LastMod = fi.lastModified();
        Dir.setPath( path );
    }
}

int QaCommonList::directoryCount()
{
    return Dir.entryInfoList( QDir::Dirs )->count();
}
