// QaCommonList.hpp
//
// Jan Borsodi <jbfdata@online.no>
// Last change: Time-stamp: <16-Feb-1999 21:13:36 amos>
//
//

#ifndef QACOMMONLIST_HPP
#define QACOMMONLIST_HPP

#include <qobject.h>
#include <qdir.h>
#include <qlistview.h>

class QaCommonList : public QObject
{
	Q_OBJECT
public:
	QaCommonList( QObject *parent = 0, const char *name = 0 );
	virtual ~QaCommonList();

	/*! \fn virtual const char * isA() const
	  Returns the class name.

	  Good for debugging.
	*/
	virtual const char * isA() const { return "QaCommonList"; };

	void setPath( const QString &path );
	void setDirTreePath( const QString &path );
	int directoryCount();
	const QFileInfoList *fileInfoList() const { return Dir.entryInfoList(); }
	const QDir &qdir() const { return Dir; }

protected:
	void checkDirTime( const QString &path );

signals:
	void directoryChanged( const QFileInfoList *f );
	void directoryDirChanged( const QFileInfoList *f );
	void item( const QFileInfo *finfo );
	void itemDirTree( const QFileInfo *finfo );
	void beginningOfList();
	void beginningOfDirList();
	void endOfList();
	void endOfDirList();

private:
	QDir Dir;
	QDateTime LastMod;
	QFileInfo LastPath;
	bool Busy;
};


#endif // QACOMMONLIST_HPP
