// 
// $Id: qaoptions.cpp,v 1.1 1999/11/19 19:21:25 amos Exp $
//
// Implementation of QaOptions class
//
// Jan Borsodi <amos@ez.no>
// Created on: <01-Jul-1999 02:16:29 amos>
//


#include "qaoptions.hpp"
#include <qtabwidget.h>
#include <qframe.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qvbuttongroup.h>
#include <qhgroupbox.h>
#include <qvgroupbox.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qgroupbox.h>
#include <qsize.h>

/*!
  \class QaOptions qaoptions.hpp
  \brief

*/

/*!
  Default constructor
*/

QaOptions::QaOptions( QWidget *parent, const char *name )
    : QFrame( parent, name )
{
    Modified = false;
    Default = false;

    QVBoxLayout *lay = new QVBoxLayout( this, 1, 1 );
    {
        pTab = new QTabWidget( this, "Options tab bar" );
        lay->addWidget( pTab, 1 );
        initTab();
//          pTab->setMinimumSize( pTab->sizeHint() );

        QHBox *hor = new QHBox( this );
        {
            hor->setSpacing( 2 );

            pOk = new QPushButton( "&Ok", hor, "options ok" );
            pCancel = new QPushButton( "&Cancel", hor, "options cancel" );
            pApply = new QPushButton( "&Apply", hor, "options apply" );
            pDefault = new QPushButton( "&Default", hor, "options cancel" );
            updateDefault();
            activateButtons();
        }
        lay->addWidget( hor, 0 );
    }
    lay->activate();
}

/*!
  Destroys the object
*/

QaOptions::~QaOptions()
{
}

void QaOptions::activateButtons()
{
    pApply->setEnabled( Modified );
    pDefault->setEnabled( Default );
}

void QaOptions::updateDefault()
{
}

void QaOptions::initTab()
{
    pTab->setMargin( 3 );

    {
        QHGroupBox *h = new QHGroupBox( pTab );
        {
            QVButtonGroup *bshow = new QVButtonGroup( "Show:", h );
            {
                (void)new QCheckBox( "Menubar", bshow );
                (void)new QCheckBox( "Toolbar", bshow );
                (void)new QCheckBox( "Statusbar", bshow );
            }
            QVBox *v = new QVBox( h );
            {
                QVButtonGroup *bwresize = new QVButtonGroup( "Window resize:", v );
                {
                    (void)new QCheckBox( "Resize to image size", bwresize );
                }
                QVButtonGroup *biresize = new QVButtonGroup( "Image resize:", v );
                {
                    (void)new QCheckBox( "Expand to window", biresize );
                    (void)new QCheckBox( "Shrink to window", biresize );
                }
            }
        }
        pTab->addTab( h, "&View" );
    }

    {
        QHGroupBox *h = new QHGroupBox( pTab );
        {
            QVButtonGroup *bshow = new QVButtonGroup( "Show:", h );
            {
                (void)new QCheckBox( "Menubar", bshow );
                (void)new QCheckBox( "Toolbar", bshow );
                (void)new QCheckBox( "Statusbar", bshow );
                (void)new QCheckBox( "Preview", bshow );
            }
            QVBox *v = new QVBox( h );
            {
                QVButtonGroup *bgui = new QVButtonGroup( "GUI:", v );
                {
                    (void)new QCheckBox( "Opaque(Smooth)", bgui );
                }
                QVButtonGroup *bcolor = new QVButtonGroup( "Colors:", v );
                {
                    (void)new QRadioButton( "None", bcolor );
                    (void)new QRadioButton( "Single", bcolor );
                    (void)new QRadioButton( "Multiple", bcolor );
                }
            }
        }
        pTab->addTab( h, "&Browser" );
    }
}
