/* qmdirdrag.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <19-Jun-1999 18:49:25 amos>
 */

#include "qmdirdrag.h"
#include <qstring.h>
#include <qwidget.h>

/*!
  \class QmDirDrag qmdirdrag.h
  \brief

  "inode/directory" MIME type is based on the KDE MIME type.
*/


/*!

*/

QmDirDrag::QmDirDrag(
    const char *DirPath,
    QWidget *pDragSource,
    const char *Name)
    : QStoredDrag("inode/directory", pDragSource, Name)
{
    int l = qstrlen(DirPath);
    QByteArray tmp(l);
    memcpy(tmp.data(), DirPath, l);
    setEncodedData(tmp);
}


/*!

*/

bool
QmDirDrag::canDecode(
    QDragMoveEvent* e)
{
    return e->provides("inode/directory");
}

/*!
  Decode it into a string.
*/

bool
QmDirDrag::decode(
    QDropEvent *e,
    QString &str)
{
    QByteArray payload = e->data("inode/directory");
    
    if(payload.size())
    {
		e->accept();
		str = QString( payload );
		str[(int)payload.size()] = '\0';
		return true;
    }
    
    return false;
}





