/* qmdirtree.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <21-Jun-1999 01:03:48 amos>
 */

#include <iostream.h>

#include "qacommonlist.hpp"
#include "qmlistview.h"
#include "qmdirtree.h"

#include <qdir.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qapplication.h>
#include <qstring.h>
#include <qlistview.h>
#include <iostream>

//  extern QaCommonList	*g_pCommonList;

/*!
  Based heavily on the dirview example by Troll Tech.
*/

/*!
*/

QmDirectory::QmDirectory(
    QmDirectory * parent,
    const char * filename)
    : QmListViewItem( parent ),
      f(filename )
{
    pTheDir = parent;
    readable = true;
}


/*!

 */

QmDirectory::QmDirectory(
    QListView * parent)
    : QmListViewItem( parent ),
      f("/")
{
    pTheDir = 0;
    readable = true;
}


/*!

 */

void
QmDirectory::setOpen(
    bool o )
{
    QListViewItem::setOpen(o);
    if( o && ! childCount() )
	{
		qDebug( "QmDirectory::setOpen: %s", fullName().ascii() );
		QString s(fullName());
		g_pCommonList->setDirTreePath( s );

		if ( g_pCommonList->qdir().count() <= 2 )
			setExpandable( false );

		if ( ! g_pCommonList->qdir().isReadable() )
		{
			readable = false;
			return;
		}

		const QFileInfoList *pFileList = g_pCommonList->qdir().entryInfoList( QDir::Dirs );

		if(pFileList)
		{
			QFileInfoListIterator it(*pFileList);
			QFileInfo *fi;
	    
			while((fi = it.current()))
			{
				++it;

				if(fi->fileName() != "." &&
				   fi->fileName() != ".." &&
				   fi->isDir())
				{
					(void) new QmDirectory(this, fi->fileName());
				}
//    				qApp->processEvents();
			}
		}
    }
//  	else
//  	{
//  		QString s(fullName());
//  		dynamic_cast<QmListView *>(listView())->setPath( s, this );
//  		g_pCommonList->setPath( s );
//  	}
}


/*!
  If a directory does not contain any directories, it will not be expandable.
*/

void
QmDirectory::setup()
{
//      QDir d(fullName());
//      d.setFilter(QDir::Dirs);

//      // If there are no directories, 2 will be returned (for `.' and `..').
    
//      if(d.count() == 2)
//  	setExpandable(false);
//      else
	setExpandable(true);
    
    QListViewItem::setup();
}


/*!

 */

QString
QmDirectory::fullName()
{
    QString s;

    if(pTheDir)
    {
		s = pTheDir->fullName();
		s.append(f.name());
		s.append("/");
    }
    else
    {
		s = "/";
    }
    
    return s;
}


/*!

 */

QString
QmDirectory::text(
    int column) const
{
    if ( column == 0 )
		return f.name();
    else if ( readable )
		return "Directory";
    else
		return "Unreadable Directory";
}

