/* ;-*-c++-*-
 * 
 * qmfilelist.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <03-Dec-1999 00:40:58 amos>
 */

#ifndef QMFILELIST_H_INCLUDED
#define QMFILELIST_H_INCLUDED

//  #include "qmthumbnaillist.h"
#include "qathumbnaillistview.hpp"
#include "qmtabbar.h"
#include "qmdetaillist.h"

#include <qcombobox.h>
#include <qlineedit.h>
#include <qpixmap.h>
#include <qtabbar.h>
#include <qstring.h>
#include <qdir.h>
#include <qevent.h>
#include <qfileinfo.h>
#include <qlistview.h>
#include <qobject.h>
#include <qwidget.h>
#include <qtabwidget.h>

class QmFileList : public QWidget
{
    Q_OBJECT
    
public:
    QmFileList(QWidget *Parent = 0,
	       const char *Name = 0);
    virtual ~QmFileList();

    QWidget		*visibleWidget(void) const;
    void setEditPath( QString s );
signals:
    /*!
      \fn void QmFileList::fileHighlighted(const char *Filename)

      This signal is emitted whenever a file is highlighted.
    */

    void		fileHighlighted(const char *Filename);


    /*!
      \fn void QmFileList::fileSelected(const char *Filename)

      This signal is emitted whenever a file is selected.
    */

    void		fileSelected(const char *Filename);


    /*!
      \fn void QmFileList::dirSelected(const char *Dirname)

      This signal is emitted whenever a directory is selected.
    */

    void		dirSelected(const char *Dirname);

public slots:
    void		setPath(const char *NewPath);
    void		queryNextImage();
    void		queryPrevImage();
    void		showing( const QString &w );

protected:
    virtual void	keyReleaseEvent(QKeyEvent *e);
    virtual bool	eventFilter(QObject *o, QEvent *e);
    
private:
    QListViewItem *	highlightNextImage(QListViewItem *);
    QListViewItem *	highlightPrevImage(QListViewItem *);
    
    QTabWidget		*pTabBar;
    QComboBox		*pFilter;
    QLineEdit		*pPath;
    QmDetailList	*pFileList;
//      QmThumbnailList	*pThumbnails;
    QaThumbnailListview	*pThumbnails;
    QString		CurrentDir;
    QPixmap		FolderIcon;
	QDir		Directory;
	QFileInfoList DirList;

    int			ThumbnailsID;
    int			FileListID;
    QStringList Matches;
    bool Fast;

private slots:
    void 		pathChanged();
	void		editPath();
    void 		itemHighlighted(QListViewItem *pItem);
    void 		itemSelected(QListViewItem *pItem);
	void		itemSelected(QaThumbnailItem *pItem);
    void		itemSelected(const char *Filename);
	void		startListing();
	void		stopListing();
	void		addItem( const QFileInfo *fi );
};

#endif // QMFILELIST_H_INCLUDED
