/* ;-*-c++-*-
 *
 * qminfoitem.h
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <03-Dec-1999 00:17:20 amos>
 */

#ifndef QMINFOITEM_H_INCLUDED
#define QMINFOITEM_H_INCLUDED

#include "qmlistviewitem.h"

#include <qfileinfo.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qpainter.h>
#include <qpalette.h>
#include <qlistview.h>

class QmInfoItem : public QmListViewItem
{
public:
    QmInfoItem(QFileInfo *pNewFileInfo, QListView *Parent);
    QmInfoItem(QFileInfo *pNewFileInfo, QmListViewItem *Parent);
    virtual ~QmInfoItem();

    QString		key(int Column, bool Ascending) const;
    QString		text(int Column) const;
    const QPixmap	*pixmap(int Column) const;

    virtual void	paintCell(QPainter *p, const QColorGroup &cg,
				  int col, int width, int align);

    static QString	friendlySize(long Value);
    const QFileInfo	*fileInfo(void) const;

    enum
    {
	Name = 0,
	Size,
	Type,
	Modified,
	Permission
    };

    enum
    {
	Jpg = 0,
	Gif,
	Xpm,
	Png,
        Bmp,
	Unknown
    };

private:
    void		initialize(void);

    QFileInfo		FileInfo;
    int			ImageType;
    QColorGroup		ColorGroup;
};

#endif // QMINFOITEM_H_INCLUDED


