/* qmlistview.cpp
 *
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <21-Jun-1999 15:58:16 amos>
 */

#include <iostream.h>

#include "qacommonlist.hpp"
#include "qmdirtree.h"
#include "qmlistview.h"

#include <qdragobject.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qevent.h>
#include <qfileinfo.h>
#include <qlistview.h>
#include <qpoint.h>
#include <qwidget.h>
#include <iostream>
#include <qlist.h>
#include <qregexp.h>


extern QaCommonList	*g_pCommonList;

/* XPM */
//  static const char * DragPic_XPM[] = {
//  "13 9 3 1",
//  " 	c None",
//  ".	c #000000",
//  "X	c #FFFFFF",
//  ".X.X.X.X.X.X.",
//  "X.X.X.X.X.X.X",
//  ".X         X.",
//  "X.         .X",
//  ".X         X.",
//  "X.         .X",
//  ".X         X.",
//  "X.X.X.X.X.X.X",
//  ".X.X.X.X.X.X."};

/*!
  \class QmListView qmlistview.h
  \brief The QmListView class is a slight customization of QListView.

  It differs in that the listview will get focus when clicked in with
  the mouse. This means that you can conveniently click on the listview
  with the mouse, then start using it with the keyboard.
*/


/*!
  Creates a new empty list view. \a Parent and \a Name are sent to the
  QListView constructor.
*/

/*
  Notice that the QDropSite constructor must be given the viewport widget
  as parent. Choosing `this' as parent will result in that drops are only
  accepted in the tiny frame around the listview.

  This goes for any QDragObjects aswell; They must have the viewport widget
  as parent.
*/

QmListView::QmListView(
    QWidget *Parent,
    const char *Name)
    : QListView(Parent, Name),
      QDropSite(this->viewport())
{
//  	cout << "Connecting to common file lister " << Name << endl;
//  	connect( g_pCommonList, SIGNAL( directoryItem( const QListViewItem *, const QFileInfo * ) ),
//  			 this, SLOT( newDirectoryItem( const QListViewItem *, const QFileInfo * ) ) );
    EnteredText = "";
}


QmListView::~QmListView()
{
//  	disconnect( g_pCommonList, SIGNAL( directoryItem( const QListViewItem *, const QFileInfo * ) ),
//  				this, SLOT( newDirectoryItem( const QListViewItem *, const QFileInfo * ) ) );
}


/*!
  Pressing a printable character will highlight the first
  item in the list starting this character, if available.
  It's column 0 that's being searched.
*/

// TODO: Fix strange bug, which sometimes makes lowercase letters match uppercase letters.

void
QmListView::keyPressEvent(
    QKeyEvent *e)
{
//      if ( !e->text().isNull() )
//      {
//          QString s;

//          QListViewItem *cur = currentItem();
//          QListViewItem *found = 0;
//          if ( cur != 0)
//          {
//              if ( e->text() == EnteredText )
//              {
//                  s = cur->text(0);
//                  if ( s.find( EnteredText, 0, true ) == 0 )
//                  {
//                      for( QListViewItem *i = cur->itemBelow(); i != 0; i = i->itemBelow() )
//                      {
//                          s = i->text(0);

//                          if ( s.find( EnteredText, 0, true ) == 0 )
//                          {
//                              found = i;
//                              setCurrentItem( i );
//                              setSelected( i, true );
//                              break;
//                          }
//                      }
//                      if ( found == 0 )
//                      {
//                          for( QListViewItem *i = firstChild(); i != 0 && i != cur; i = i->itemBelow() )
//                          {
//                              s = i->text(0);

//                              if( s.find( EnteredText, 0, true ) == 0 )
//                              {
//                                  found = i;
//                                  setCurrentItem( i );
//                                  setSelected( i, true );
//                                  break;
//                              }
//                          }
//                      }
//                  }
//              }
//              else
//                  found = 0;
//          }

//          if ( found == 0 )
//          {
//              EnteredText = e->text();

//              for( QListViewItem *i = firstChild(); i != 0; i = i->itemBelow() )
//              {
//                  s = i->text(0);

//                  if( s.find( EnteredText, 0, true ) == 0 )
//                  {
//                      setCurrentItem( i );
//                      setSelected( i, true );
//                      break;
//                  }
//              }
//          }
//      }
    QListView::keyPressEvent(e);
//      if ( e->isAccepted() )
//          return;
//      e->accept();
}


/*!
  
*/

void
QmListView::mousePressEvent(
    QMouseEvent *e)
{
    setFocus();
    
    QListView::mousePressEvent(e);
}


/*!

 */

// void
// QmListView::mouseReleaseEvent(
//     QMouseEvent *e)
// {
//     if((e->state() & LeftButton) == 0)
// 	LeftButtonDown = false;
// }


/*!

 */

// void
// QmListView::leaveEvent(
//     QEvent *e)
// {
//     cout << "QmListView::leaveEvent(): " << e->type() << endl;
    
//     if(currentItem() != 0 && LeftButtonDown == true)
//     {
// 	QTextDrag *d = new QTextDrag(currentItem()->text(0), this);
// 	d->setPixmap(QPixmap(DragPic_XPM), QPoint(8, 8));
// 	d->dragCopy();
//     }
//}


/*!

 */

void
QmListView::dragEnterEvent(
    QDragEnterEvent *e)
{
//    cout << "QmListView::dragEnterEvent()\n";
    
    if(QTextDrag::canDecode(e))
    {
	e->accept();
    }

    // Give the user some feedback
    
    QString t;
    for(int i = 0; e->format(i); i++)
    {
	if(*(e->format(i)))
	{
	    if( ! t.isEmpty())
		t += "\n";
	    t += e->format(i);

	    cout << t << endl;
	}
    }
}


/*!

 */

void
QmListView::dragMoveEvent(
    QDragMoveEvent * /*e*/)
{
//    cout << "QmListView::dragMoveEvent()\n";
}


/*!

 */

void
QmListView::dragLeaveEvent(
    QDragLeaveEvent * /*e*/)
{
//     if(currentItem() != 0)
//     {
//  	QTextDrag *d = new QTextDrag(currentItem()->text(0), viewport());
//  	d->setPixmap(QPixmap(DragPic_XPM), QPoint(8, 8));
//  	d->dragCopy();
//     }
    
//    cout << "QmListView::dragLeaveEvent()\n";
}


/*!

 */

void
QmListView::dropEvent(
    QDropEvent *e)
{
    cout << "QmListView::dropEvent(): ";
    
    // Try to decode to the data

    QString str;
    if(QTextDrag::decode(e, str))
    {
	cout << str << endl;
	return;
    }

    cout << endl;
}

//  void QmListView::newDirectoryItem( const QListViewItem *vi, const QFileInfo *fi )
//  {
//  	if( fi->fileName() != "." &&
//  		fi->fileName() != ".." )
//  	{
//  		QmDirectory *d = const_cast<QmDirectory *>( dynamic_cast<const QmDirectory *>(vi) );
//  		(void) new QmDirectory( d, fi->fileName());
//  	}
//  }

//  void QmListView::setPath( QString s, QListViewItem *vi )
//  {
//  	g_pCommonList->setPath( s, vi );

//  }
