/* ;-*-c++-*-
 * 
 * qmpreviewitem.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <19-Jun-1999 18:57:31 amos>
 */

#ifndef QMPREVIEWITEM_H_INCLUDED
#define QMPREVIEWITEM_H_INCLUDED

#include "qmlistviewitem.h"

#include <qfileinfo.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qpainter.h>
#include <qpalette.h>
#include <qlistview.h>

class QmPreviewItem : public QmListViewItem
{
public:
    QmPreviewItem(QFileInfo *pNewFileInfo, QListView *Parent);
    QmPreviewItem(QFileInfo *pNewFileInfo, QmListViewItem *Parent);
    virtual ~QmPreviewItem();

    QString		key(int Column, bool Ascending) const;
    QString		text(int Column) const;
    const QPixmap	*pixmap(int Column) const;

    virtual void	setup(void);

    virtual void	paintCell(QPainter *p, const QColorGroup &cg,
				  int col, int width, int align);
private:
    void		initialize(void);
    
    enum
    {
	Jpg = 0,
	Gif,
	Xpm,
	Png,
	Unknown
    };

    QFileInfo		FileInfo;
    int			ImageType;
    QPixmap		Thumbnail;
    QColorGroup		ColorGroup;
};

#endif // QMPREVIEWITEM_H_INCLUDED


