/* ;-*-c++-*-
 * 
 * qmtabbar.h
 * 
 * Marius Sundbakken <marius@fix.no>
 *
 * Last modified: Time-stamp: <26-Apr-1999 22:03:34 amos>
 */

#ifndef QMTABBAR_H_INCLUDED
#define QMTABBAR_H_INCLUDED

#include <qtabbar.h>
#include <qwidgetstack.h>
#include <qevent.h>
#include <qwidget.h>

class QmFileList;

class QmTabBar : public QWidget
{
    Q_OBJECT
    
public:
    QmTabBar(QTabBar::Shape TabBarShape,
	     QWidget *Parent = 0,
	     const char *Name = 0);
    virtual ~QmTabBar();

	friend class QmFileList;
    int			addWidget(QWidget *pNewWidget, const char *Label);
    QWidget		*visibleWidget(void) const;
    int			currentTab(void) const;
	QTabBar *tabBar() const { return pTabBar; }

signals:
	void aboutToShow( int );
	void aboutToShow( QWidget * );

public slots:
	void raiseWidget( int );

protected:
    virtual void	paintEvent(QPaintEvent *e);

private:
    QTabBar		*pTabBar;
    QWidgetStack	*pStack;
    int			TabCount;
};

#endif // QMTABBAR_H_INCLUDED
